#economic data
import pandas as pd

predf = pd.read_csv('BAE_data.csv')
predf.dropna(inplace=True)

pop = predf[predf['Description']== 'Population (persons) 3/']
inc = predf[predf['Description']== 'Per capita personal income (dollars) 4/']
emp = predf[predf['Description']== 'Total employment']

pop.rename(columns={'2012': '2012_pop','2013': '2013_pop','2014': '2014_pop','2015': '2015_pop','2016': '2016_pop','2017': '2017_pop','2018': '2018_pop','2019': '2019_pop'}, inplace=True)
pop = pop[['2012_pop','2013_pop','2014_pop','2015_pop','2016_pop','2017_pop','2018_pop','2019_pop']].reset_index(drop=True)
inc.rename(columns={'2012': '2012_inc','2013': '2013_inc','2014': '2014_inc','2015': '2015_inc','2016': '2016_inc','2017': '2017_inc','2018': '2018_inc','2019': '2019_inc'}, inplace=True)
inc = inc[['2012_inc','2013_inc','2014_inc','2015_inc','2016_inc','2017_inc','2018_inc','2019_inc']].reset_index(drop=True)
emp.rename(columns={'2012': '2012_emp','2013': '2013_emp','2014': '2014_emp','2015': '2015_emp','2016': '2016_emp','2017': '2017_emp','2018': '2018_emp','2019': '2019_emp'}, inplace=True)
emp = emp[['2012_emp','2013_emp','2014_emp','2015_emp','2016_emp','2017_emp','2018_emp','2019_emp']].reset_index(drop=True)

df = predf[['GeoFips','GeoName']].drop_duplicates().reset_index(drop=True)
df['GeoFips'] = df['GeoFips'].apply(lambda x: str(x).zfill(5))
df = df.join(pop).join(inc).join(emp)

df.to_csv('pop_inc_emp.csv', index=False)


#demographic data
import glob

for file in glob.glob('*_race.csv'):
	df = pd.read_csv(file)
	df = df[(4<df['YEAR']) & (df['YEAR']<13)]
	df['STATE'] = df.STATE.apply(lambda x: str(x).zfill(2))
	df['COUNTY'] = df.COUNTY.apply(lambda x: str(x).zfill(3))
	df['YEAR'] = df['YEAR'].replace([5,6,7,8,9,10,11,12], [2012,2013,2014,2015,2016,2017,2018,2019])
	df['county'] = df['STATE'] + df['COUNTY']
	df['per_female'] = (df['TOT_FEMALE'] /df['TOT_POP'])*100
	df['per_white'] = (df['WA_MALE'] + df['WA_FEMALE'])/df['TOT_POP']*100
	df['per_black'] = (df['BA_MALE'] + df['BA_FEMALE'])/df['TOT_POP']*100
	df['per_ia'] = (df['IA_MALE'] + df['IA_FEMALE'])/df['TOT_POP']*100
	df['per_aa'] = (df['AA_MALE'] + df['AA_FEMALE'])/df['TOT_POP']*100
	df['per_na'] = (df['NA_MALE'] + df['NA_FEMALE'])/df['TOT_POP']*100
	df['per_na'] = (df['NA_MALE'] + df['NA_FEMALE'])/df['TOT_POP']*100
	df['per_h'] = (df['H_MALE'] + df['H_FEMALE'])/df['TOT_POP']*100
	df['per_mult'] = (df['TOM_MALE'] + df['TOM_FEMALE'])/df['TOT_POP']*100
	df = df[['county','STNAME','CTYNAME','YEAR','AGEGRP','TOT_POP','per_female','per_white','per_black','per_h','per_ia','per_aa','per_na','per_mult']]
	keep = df[df['AGEGRP']==0].reset_index(drop=True)
	keep['u20'] = df[(0<df['AGEGRP']) & (df['AGEGRP']<5)].groupby(['YEAR','county'])['TOT_POP'].sum().reset_index(drop=True)/ (df[(df['AGEGRP']==0)]).groupby(['YEAR','county'])['TOT_POP'].sum().reset_index(drop=True)*100
	keep['u40'] = df[(4<df['AGEGRP']) & (df['AGEGRP']<9)].groupby(['YEAR','county'])['TOT_POP'].sum().reset_index(drop=True)/ (df[(df['AGEGRP']==0)].groupby(['YEAR','county'])['TOT_POP']).sum().reset_index(drop=True)*100
	keep['u60'] = df[(8<df['AGEGRP']) & (df['AGEGRP']<13)].groupby(['YEAR','county'])['TOT_POP'].sum().reset_index(drop=True)/ (df[(df['AGEGRP']==0)].groupby(['YEAR','county'])['TOT_POP']).sum().reset_index(drop=True)*100
	keep['u80'] = df[(12<df['AGEGRP']) & (df['AGEGRP']<17)].groupby(['YEAR','county'])['TOT_POP'].sum().reset_index(drop=True)/ (df[(df['AGEGRP']==0)].groupby(['YEAR','county'])['TOT_POP']).sum().reset_index(drop=True)*100
	keep['p80'] = df[(16<df['AGEGRP'])].groupby(['YEAR','county'])['TOT_POP'].sum().reset_index(drop=True)/ (df[(df['AGEGRP']==0)].groupby(['YEAR','county'])['TOT_POP']).sum().reset_index(drop=True)*100
	keep.to_csv(file[:-4]+'_clean.csv', index=False)


#put econ and demo data together correctly
econ = pd.read_csv('pop_inc_emp_rev.csv')
econ['state_FIPS'] = econ['GeoFips'].apply(lambda x: str(x).zfill(5)[:2]).astype(int)
year_dict = {'harvey':2017, 'irma':2017, 'michael': 2018, 'matthew':2016, 'hermine':2016, 'dorian':2019, 'florence':2018}
state_dict = {'harvey':[48], 'irma':[12, 13, 45], 'michael': [1, 12, 13], 'matthew':[12, 13, 45], 'hermine':[12], 'dorian':[12,13,37,45], 'florence':[37,45,51]}

econ_big= []
hurricanes = ['harvey','irma', 'michael', 'matthew', 'hermine', 'dorian', 'florence']
suffixes = ['_pop', '_inc', '_emp']
for h in hurricanes:
	col_list = [str(year_dict[h])+x for x in suffixes]+['state_FIPS']+['GeoFips']
	a = econ[col_list]
	a = a[a['state_FIPS'].isin(state_dict[h])]
	a.columns = ['population','income','employment','state_FIPS','GeoFips']
	a['hurricane'] = h
	econ_big.append(a)
econ_fin = pd.concat(econ_big, ignore_index = True)


df_list = []
for f in glob.glob('*_clean.csv'):
	df = pd.read_csv(f)
	df_list.append(df)
demo = pd.concat(df_list)
demo.drop(['CTYNAME','AGEGRP','TOT_POP','STNAME'], axis =1, inplace=True)

demo['state_FIPS'] = demo['county'].apply(lambda x: str(x).zfill(5)[:2]).astype(int)

fix_list = []
for h in hurricanes:
	b = demo[demo['YEAR']==year_dict[h]]
	b = b[b['state_FIPS'].isin(state_dict[h])]
	b['hurricane'] = h
	fix_list.append(b)
demo_fin = pd.concat(fix_list, ignore_index=True)


final = demo_fin.merge(econ_fin, left_on = ['county','hurricane'], right_on = ['GeoFips','hurricane'], how ='outer')
final['county']=final.county.fillna(final.GeoFips)
final['YEAR']= final.hurricane.apply(lambda x: year_dict[x])

final['other_race'] = final['per_ia'] + final['per_na'] +final['per_mult'] 
final['middle_age'] = final['u40'] + final['u60']
final['elderly'] = final['u80'] + final['p80']

final = final[['hurricane','YEAR','county','per_female','per_white', 'per_black', 'per_aa', 'other_race', 'u20', 'middle_age', 'elderly','employment', 'population','income']]
final.to_csv('econ_demo_full.csv')
