#finaldf_maker.py
#run using downsample
#script that calculates and graphs the interaction beta for several times
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import gc

full_ed = pd.read_csv('econ_demo_full.csv')
fin = pd.read_csv('financials/financials.csv')

dflist = []
storms = ['harvey','irma','dorian','florence','hermine','matthew','michael']
for s in storms: 
	dfs = pd.read_csv(s+'_final_sm.csv')
	dfs['county'] = dfs['county'].apply(lambda x: np.where(x==12025, 12086, x))
	print (s)
	print (len(dfs))	
	print ('length of counties pre')
	print (dfs.county.nunique())
	ed = full_ed[full_ed['hurricane'] ==s]
	print('inner merge with econ/demo data')
	df = dfs.merge(ed, left_on='county', right_on = 'county', how = 'left')
	df.sort_values(by=['year','month'], inplace = True)
	print ('length of counties post')
	print (df.county.nunique())
	df.to_csv('econ_'+s+'final.csv', index=False)
	dflist.append(df)

df_final = pd.concat(dflist)

del dflist, ed, dfs, df, full_ed
gc.collect()

df_final['state'] = df_final.county.apply(lambda x:str(x)[:2])
df_final['state'] = df_final['state'].astype(int)

df_final.to_csv('correct_full_final.csv', index=False)

print ('df_final columns')
print (df_final.columns)
print ('fin columns')
print (fin.columns)
final = pd.merge(df_final, fin, left_on =['hurricane','state'], right_on =['hurricane','state_FIPS'])
final.to_csv('correct_full_final_fin.csv', index=False)

