#run 1 yr dids for each hurricane 
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import seaborn as sns
import statsmodels.formula.api as smf
import os
import gc
from numpy import inf
from sklearn.preprocessing import MinMaxScaler

df = pd.read_csv('Desktop/Desktop/correct_full_final_fin_nodupe.csv')
df.log_light.replace(-inf, np.log(0.0000000000001), inplace =True)
df = df.drop_duplicates()
print ('DROP DUPLICATES')

hurricanes =['hermine','matthew','harvey', 'irma','florence','michael','dorian']

long_model_log = 'log_light ~ fema_int + post+ fema_treat + urban+state_FIPS+per_female+per_white+per_black+ per_aa + other_race+ u20+middle_age +elderly +employment+population+income'
long_model_log_ia = 'log_light ~ fema_int_ia + post+ fema_IA + urban+state_FIPS+per_female+per_white+per_black+ per_aa + other_race + u20+ middle_age + elderly +employment+population+income'

beta_list = []
for h in hurricanes:
        newdf = df[df.hurricane == h].copy()
        print ('missing vals: '+ str(newdf.isna().sum().sum()))
        mod = smf.ols(formula =long_model_log, data =newdf, missing='drop')
        res = mod.fit()
        print ('this model is for hurricane: '+h.upper())
        print ('these are OVERALL aggregate results')
        print ('ANY ASSISTANCE')
        #print (res.summary())
        beta_list.append([h, res.params['fema_int'], res.pvalues['fema_int']])
print ('results DF')
res_df = pd.DataFrame(beta_list, columns =['hurricane','fema','pval'])
print (res_df)

ia_beta_list = []
for h in hurricanes:
        newdf = df[df.hurricane == h]
        mod = smf.ols(formula =long_model_log_ia, data =newdf, missing='drop')
        res = mod.fit()
        print ('this model is for hurricane: '+h.upper())
        print ('these are OVERALL aggregate results')
        print ('INDIVIDUAL ASSISTANCE')
        #print (res.summary())
        ia_beta_list.append([h, res.params['fema_int_ia'], res.pvalues['fema_int_ia']])
print ('IA results DF')
iares_df = pd.DataFrame(ia_beta_list, columns = ['hurricane', 'fema_ia','pval'])
print (iares_df)

