#loo_maps.py
import pandas as pd
import numpy as np
from numpy import inf
import gc
import statsmodels.formula.api as smf
import geopandas as gpd
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import seaborn as sns
from matplotlib.colors import TwoSlopeNorm
import matplotlib.patches as mpatches
from matplotlib.colors import ListedColormap

df = pd.read_csv('Desktop/Desktop/correct_full_final_fin_nodupe.csv')
df.log_light.replace(-inf, np.log(0.0000000000001), inplace =True)

#option here 
df = df.drop_duplicates()
print ('DROP DUPLICATES')

long_model_log = 'log_light ~ fema_int + post+ fema_treat + urban+state_FIPS+per_female+per_white+per_black+ per_aa + other_race+ u20+middle_age +elderly +employment+population+income'
long_model_log_ia = 'log_light ~ fema_int_ia + post+ fema_IA + urban+state_FIPS+per_female+per_white+per_black+ per_aa + other_race + u20+ middle_age + elderly +employment+population+income'

hurricanes =['hermine','matthew','harvey', 'irma','florence','michael','dorian']

beta_list = []
for h in hurricanes:
        newdf = df[df.hurricane == h]
        for x in newdf.county.unique():
                b = newdf[newdf.county != x]
                mod = smf.ols(formula =long_model_log, data =b, missing='drop')
                res = mod.fit()
                print ('this model is for hurricane: '+h.upper())
                print (res.summary())
                beta_list.append([h, x, res.params['fema_int'], res.pvalues['fema_int']])
print ('NORMAL dataframe')
diff_ndf = pd.DataFrame(beta_list, columns = ['hurricane','county','coi','pval'])
#diff_ndf.to_csv('LOO_normal_nodupes.csv', index = False)

ia_beta_list = []
for h in hurricanes:
        newdf = df[df.hurricane == h]
        for x in newdf.county.unique():
                b = newdf[newdf.county != x]
                mod = smf.ols(formula =long_model_log_ia, data =b, missing='drop')
                res = mod.fit()
                print ('this model is for hurricane: '+h.upper())
                print (res.summary())
                ia_beta_list.append([h, x, res.params['fema_int_ia'], res.pvalues['fema_int_ia']])
print ('IA dataframe')
diff_iadf = pd.DataFrame(ia_beta_list, columns = ['hurricane','county','coi_ia','pval'])
#diff_iadf.to_csv('LOO_ia_nodupes.csv', index = False)


#start from here if datasets already built
ind = pd.read_csv('Desktop/fema_indicators.csv')
tdf = ind[['hurricane','county','fema_treat', 'fema_IA']]

#shape files
df = gpd.read_file('Downloads/dataverse_files/CountiesBEA.shp')         # correct fips here
df['FIPS'] = df['FIPS_BEA'].astype(int)
cs = df[['geometry', 'FIPS']]
cs.to_crs(epsg= 4326, inplace=True)



# 12 month
diff_ndf_12m = pd.read_csv('Desktop/Desktop/LOO_normal_1year_nodupes_local.csv')
diff_iadf_12m = pd.read_csv('Desktop/Desktop/LOO_ia_1year_nodupes_local.csv')
diff_df_12m = pd.merge(diff_ndf_12m, diff_iadf_12m, left_on =['hurricane','county'], right_on =['hurricane','county'])
full_df = pd.merge(diff_df_12m, tdf, left_on =['hurricane','county'], right_on =['hurricane','county'])
dict_1y = {'hermine': -0.012319,'matthew': -0.040512,'harvey': -0.002309,'irma':0.0,'florence': 0.072602,'michael': -0.018790,'dorian': 0.131694}
ia_dict_1y = {'hermine': -8.305838e-02,'matthew': -1.657053e-01,'harvey': 1.945521e-02,'irma': -6.792869e-02,'florence': 7.306383e-02,'michael': -4.971115e-02, 'dorian':0.0}
full_df['base_n'] = full_df['hurricane'].map(dict_1y)
full_df['base_ia'] = full_df['hurricane'].map(ia_dict_1y)
    

#overall 
#diff_ndf = pd.read_csv('Desktop/Desktop/LOO_normal_nodupes.csv')
#diff_iadf = pd.read_csv('Desktop/Desktop/LOO_ia_nodupes.csv')
#diff_iadf.columns = ['hurricane','county','coi_ia','pval_ia']

#diff_df = pd.merge(diff_ndf, diff_iadf, left_on =['hurricane','county'], right_on =['hurricane','county'])
#full_df = pd.merge(diff_df, tdf, left_on =['hurricane','county'], right_on =['hurricane','county'])

#normal_dict = {'hermine': -0.029264,'matthew': -0.121274,'harvey': -0.018460,'irma':0.0,'florence': 0.009010,'michael': 0.034283,'dorian': -0.093473}
#ia_dict = {'hermine': -4.034148e-02,'matthew': -1.474698e-01,'harvey': -1.575077e-02,'irma': -1.186785e-01,'florence': 3.616363e-02,'michael': 7.017945e-02, 'dorian':0.0}

#full_df['base_n'] = full_df['hurricane'].map(normal_dict)
full_df['diff_n'] = full_df['base_n'] - full_df['coi']
full_df['pdiff_n'] = full_df['diff_n']*100

#full_df['base_ia'] = full_df['hurricane'].map(ia_dict)
full_df['diff_ia'] = full_df['base_ia'] - full_df['coi_ia']
full_df['pdiff_ia'] = full_df['diff_ia']*100

full_df['plot_n'] = np.where(full_df['fema_treat']==1, full_df['pdiff_n'], 0) 
full_df['plot_ia'] = np.where(full_df['fema_IA']==1, full_df['pdiff_ia'], 0) 

#test normalizing by the baseline
full_df['test'] = (full_df['diff_n']/np.abs(full_df['base_n']))*100
full_df['test_ia'] = (full_df['diff_ia']/np.abs(full_df['base_ia']))*100
full_df['plot_ntest'] = np.where(full_df['fema_treat']==1, full_df['test'], 0) 
full_df['plot_iatest'] = np.where(full_df['fema_IA']==1, full_df['test_ia'], 0) 

#palettes
cmap_neg = sns.diverging_palette(10, 240, center='light', as_cmap=True)
cmap_pos = sns.diverging_palette(150, 275, center='light', as_cmap=True)

#colorbar
purple_patch = mpatches.Patch(color='#875fdb', label='more increase in radiance')
green_patch = mpatches.Patch(color='#3b8464', label='less increase in radiance')
blue_patch = mpatches.Patch(color='#417ca8', label='less decrease in radiance')
red_patch = mpatches.Patch(color='#da3b46', label='more decrease in radiance')
plt.legend(loc='upper right',handles=[purple_patch,green_patch,red_patch,blue_patch],ncol=2)
plt.show()


'''
EXTRA
#overall - loo 
full_df['greater_zero'] = np.where(full_df['diff_n']>0, 1, 0) 
full_df['less_zero'] = np.where(full_df['diff_n']<0, 1, 0) 

full_df['greater_zero_ia'] = np.where(full_df['diff_ia']>0, 1, 0) 
full_df['less_zero_ia'] = np.where(full_df['diff_ia']<0, 1, 0) 

full_df.groupby(['hurricane'])['greater_zero'].value_counts()
full_df.groupby(['hurricane'])['less_zero'].value_counts()

full_df.groupby(['hurricane'])['greater_zero_ia'].value_counts()
full_df.groupby(['hurricane'])['less_zero_ia'].value_counts()

#overall - loo 
full_df['greater_zero'] = np.where(full_df['diff_n']>0, 1, 0) 
full_df['less_zero'] = np.where(full_df['diff_n']<0, 1, 0) 

full_df['greater_zero_ia'] = np.where(full_df['diff_ia']>0, 1, 0) 
full_df['less_zero_ia'] = np.where(full_df['diff_ia']<0, 1, 0) 

full_df.groupby(['hurricane'])['greater_zero'].value_counts()
full_df.groupby(['hurricane'])['less_zero'].value_counts()

full_df.groupby(['hurricane'])['greater_zero_ia'].value_counts()
full_df.groupby(['hurricane'])['less_zero_ia'].value_counts()

#just loo 
full_df['greater_LOO'] = np.where(full_df['coi']>0, 1, 0) 
full_df['less_LOO'] = np.where(full_df['coi']<0, 1, 0) 
full_df['greater_LOO_ia'] = np.where(full_df['coi_ia']>0, 1, 0) 
full_df['less_LOO_ia'] = np.where(full_df['coi_ia']<0, 1, 0) 

full_df.groupby(['hurricane'])['greater_LOO'].value_counts()
full_df.groupby(['hurricane'])['less_LOO'].value_counts()
full_df.groupby(['hurricane'])['greater_LOO_ia'].value_counts()
full_df.groupby(['hurricane'])['less_LOO_ia'].value_counts()
'''

#hermine
betas_her = full_df[full_df.hurricane == 'hermine']
cs_her = cs[(cs.FIPS.isin(betas_her.county.unique()))]
full_her = cs_her.merge(betas_her, left_on= 'FIPS', right_on = 'county')
geo_her= gpd.GeoDataFrame(full_her, crs= {'init': 'epsg:4326'}, geometry= full_her.geometry).to_crs(epsg=4326)

#matthew
betas_matt = full_df[full_df.hurricane == 'matthew']
cs_matt = cs[(cs.FIPS.isin(betas_matt.county.unique()))]
full_matt = cs_matt.merge(betas_matt, left_on= 'FIPS', right_on = 'county')
geo_matt = gpd.GeoDataFrame(full_matt, crs= {'init': 'epsg:4326'}, geometry= full_matt.geometry).to_crs(epsg=4326)

#irma
betas_irma = full_df[full_df.hurricane == 'irma']
cs_irma = cs[(cs.FIPS.isin(betas_irma.county.unique()))]
full_irma = cs_irma.merge(betas_irma, left_on= 'FIPS', right_on = 'county')
geo_irma= gpd.GeoDataFrame(full_irma, crs= {'init': 'epsg:4326'}, geometry= full_irma.geometry).to_crs(epsg=4326)

#harvey
betas_harv = full_df[full_df.hurricane == 'harvey']
cs_harv = cs[(cs.FIPS.isin(betas_harv.county.unique()))]
full_harv = cs_harv.merge(betas_harv, left_on= 'FIPS', right_on = 'county')
geo_harv= gpd.GeoDataFrame(full_harv, crs= {'init': 'epsg:4326'}, geometry= full_harv.geometry).to_crs(epsg=4326)

#michael
betas_mich = full_df[full_df.hurricane == 'michael']
cs_mich = cs[(cs.FIPS.isin(betas_mich.county.unique()))]
full_mich = cs_mich.merge(betas_mich, left_on= 'FIPS', right_on = 'county')
geo_mich = gpd.GeoDataFrame(full_mich, crs= {'init': 'epsg:4326'}, geometry= full_mich.geometry).to_crs(epsg=4326)

#florence
betas_flo = full_df[full_df.hurricane == 'florence']
cs_flo = cs[(cs.FIPS.isin(betas_flo.county.unique()))]
full_flo = cs_flo.merge(betas_flo, left_on= 'FIPS', right_on = 'county')
geo_flo = gpd.GeoDataFrame(full_flo, crs= {'init': 'epsg:4326'}, geometry= full_flo.geometry).to_crs(epsg=4326)

#dorian
betas_dor = full_df[full_df.hurricane == 'dorian']
cs_dor = cs[(cs.FIPS.isin(betas_dor.county.unique()))]
full_dor = cs_dor.merge(betas_dor, left_on= 'FIPS', right_on = 'county')
geo_dor = gpd.GeoDataFrame(full_dor, crs= {'init': 'epsg:4326'}, geometry= full_dor.geometry).to_crs(epsg=4326)


'''
#plot together, CUMULATIVE aid (leave out IRMA)
fig, ((ax1, ax2, ax3), (ax4, ax5, ax6)) = plt.subplots(nrows=2, ncols=3)
divnorm = TwoSlopeNorm(vmin=geo_her[geo_her.fema_treat==1]['plot_ntest'].min(), vcenter=geo_her[geo_her.fema_treat==1]['plot_ntest'].mean(), vmax=geo_her[geo_her.fema_treat==1]['plot_ntest'].max())
geo_her.plot('plot_ntest', ax=ax1, color='lightgrey', legend =True, linewidth=.5)
geo_her[geo_her.fema_treat==1].plot('plot_ntest',cmap=cmap_neg, ax=ax1, edgecolor='grey',linewidth=.5, norm=divnorm,legend =True)          #
ax1.set_title('Hermine')
ax1.axis('off')

divnorm = TwoSlopeNorm(vmin=geo_matt['plot_ntest'].min(), vcenter=geo_matt['plot_ntest'].mean(), vmax=geo_matt['plot_ntest'].max())
geo_matt.plot('plot_ntest', ax=ax2, color='lightgrey', legend =True, linewidth=.5)
geo_matt[geo_matt.fema_treat==1].plot('plot_ntest',cmap=cmap_neg, ax=ax2, edgecolor='grey',linewidth=.5, norm=divnorm,legend =True)        #, norm=divnorm
ax2.set_title('Matthew')
ax2.axis('off')

divnorm = TwoSlopeNorm(vmin=geo_harv['plot_ntest'].min(), vcenter=geo_harv['plot_ntest'].mean(), vmax=geo_harv['plot_ntest'].max())
geo_harv.plot('plot_ntest', ax=ax3, color='lightgrey', legend =True, linewidth=.5)
geo_harv[geo_harv.fema_treat==1].plot('plot_ntest',cmap=cmap_neg, ax=ax3, edgecolor='grey',linewidth=.5, norm=divnorm,legend =True)        #, norm=divnorm
ax3.set_title('Harvey')
ax3.axis('off')

divnorm = TwoSlopeNorm(vmin=geo_mich['plot_ntest'].min(), vcenter=geo_mich['plot_ntest'].mean(), vmax=geo_mich['plot_ntest'].max())
geo_mich.plot('plot_ntest', ax=ax4, color='lightgrey', legend =True, linewidth=.5)
geo_mich[geo_mich.fema_treat==1].plot('plot_ntest',cmap=cmap_pos, ax=ax4, edgecolor='grey',linewidth=.5, norm=divnorm,legend =True)        #, norm=divnorm
ax4.set_title('Michael')
ax4.axis('off')

divnorm = TwoSlopeNorm(vmin=geo_flo['plot_ntest'].min(), vcenter=geo_flo['plot_ntest'].mean(), vmax=geo_flo['plot_ntest'].max())
geo_flo.plot('plot_ntest', ax=ax5, color='lightgrey', legend =True, linewidth=.5)
geo_flo[geo_flo.fema_treat==1].plot('plot_ntest',cmap=cmap_pos, ax=ax5, edgecolor='grey',linewidth=.5, norm=divnorm,legend =True)  #, norm=divnorm
ax5.set_title('Florence')
ax5.axis('off')

divnorm = TwoSlopeNorm(vmin=geo_dor['plot_ntest'].min(), vcenter=geo_dor['plot_ntest'].mean(), vmax=geo_dor['plot_ntest'].max())
geo_dor.plot('plot_ntest', ax=ax6, color='lightgrey', legend =True, linewidth=.5)
geo_dor[geo_dor.fema_treat==1].plot('plot_ntest',cmap=cmap_neg, ax=ax6, edgecolor='grey',linewidth=.5, norm=divnorm,legend =True)  #, norm=divnorm
ax6.set_title('Dorian')
ax6.axis('off')
fig.suptitle('Any Aid')
plt.show()

'''




#plot together, CUMULATIVE aid (leave out IRMA)
fig, ((ax1, ax2, ax3), (ax4, ax5, ax6)) = plt.subplots(nrows=2, ncols=3)
divnorm = TwoSlopeNorm(vmin=-1, vcenter=0, vmax=1)
geo_her.plot('plot_n', ax=ax1, cmap=cmap_neg, legend =True, linewidth=.5, norm=divnorm)
geo_her[geo_her.fema_treat==1].plot('plot_n',cmap=cmap_neg, ax=ax1, edgecolor='grey',linewidth=.5, norm=divnorm)          #
ax1.set_title('Hermine')
ax1.axis('off')

divnorm = TwoSlopeNorm(vmin=-1, vcenter=0, vmax=1)
#divnorm = TwoSlopeNorm(vmin=geo_matt['plot_n'].min(), vcenter=0, vmax=geo_matt['plot_n'].max())
geo_matt.plot('plot_n', ax=ax2, cmap=cmap_neg, legend =True, linewidth=.5, norm=divnorm)
geo_matt[geo_matt.fema_treat==1].plot('plot_n',cmap=cmap_neg, ax=ax2, edgecolor='grey',linewidth=.5, norm=divnorm)        #, norm=divnorm
ax2.set_title('Matthew')
ax2.axis('off')

divnorm = TwoSlopeNorm(vmin=-1, vcenter=0, vmax=1)
#divnorm = TwoSlopeNorm(vmin=geo_harv['plot_n'].min(), vcenter=0, vmax=geo_harv['plot_n'].max())
geo_harv.plot('plot_n', ax=ax3, cmap=cmap_neg, legend =True, linewidth=.5, norm=divnorm)
geo_harv[geo_harv.fema_treat==1].plot('plot_n',cmap=cmap_neg, ax=ax3, edgecolor='grey',linewidth=.5, norm=divnorm)        #, norm=divnorm
ax3.set_title('Harvey')
ax3.axis('off')

#divnorm = TwoSlopeNorm(vmin=geo_mich['plot_n'].min(), vcenter=0, vmax=geo_mich['plot_n'].max())
divnorm = TwoSlopeNorm(vmin=-1, vcenter=0, vmax=1)
geo_mich.plot('plot_n', ax=ax4, cmap=cmap_pos, legend =True, linewidth=.5, norm=divnorm)
geo_mich[geo_mich.fema_treat==1].plot('plot_n',cmap=cmap_pos, ax=ax4, edgecolor='grey',linewidth=.5, norm=divnorm)        #, norm=divnorm
ax4.set_title('Michael')
ax4.axis('off')

#divnorm = TwoSlopeNorm(vmin=geo_flo['plot_n'].min(), vcenter=0, vmax=geo_flo['plot_n'].max())
divnorm = TwoSlopeNorm(vmin=-1, vcenter=0, vmax=1)
geo_flo.plot('plot_n', ax=ax5, cmap=cmap_pos, legend =True, linewidth=.5, norm=divnorm)
geo_flo[geo_flo.fema_treat==1].plot('plot_n',cmap=cmap_pos, ax=ax5, edgecolor='grey',linewidth=.5, norm=divnorm)  #, norm=divnorm
ax5.set_title('Florence')
ax5.axis('off')

#divnorm = TwoSlopeNorm(vmin=geo_dor['plot_n'].min(), vcenter=0, vmax=geo_dor['plot_n'].max())
divnorm = TwoSlopeNorm(vmin=-1, vcenter=0, vmax=1)
geo_dor.plot('plot_n', ax=ax6, cmap=cmap_neg, legend =True, linewidth=.5, norm=divnorm)
geo_dor[geo_dor.fema_treat==1].plot('plot_n',cmap=cmap_neg, ax=ax6, edgecolor='grey',linewidth=.5, norm=divnorm)  #, norm=divnorm
ax6.set_title('Dorian')
ax6.axis('off')
fig.suptitle('Any Aid')
plt.show()


#plot together, INVIDIDUAL aid (leave out dorian)
fig, ((ax1, ax2, ax3), (ax4, ax5, ax6)) = plt.subplots(nrows=2, ncols=3)
divnorm = TwoSlopeNorm(vmin=-1, vcenter=0, vmax=1)
geo_her.plot('plot_ia', ax=ax1, cmap=cmap_neg, legend =True,linewidth=.5, norm=divnorm)
geo_her[geo_her.fema_IA==1].plot('plot_ia',cmap=cmap_neg, ax=ax1, edgecolor='grey',linewidth=.5, norm=divnorm)
ax1.set_title('Hermine')
ax1.axis('off')

divnorm = TwoSlopeNorm(vmin=-1, vcenter=0, vmax=1)
geo_matt.plot('plot_ia', ax=ax2, cmap=cmap_neg, legend =True,linewidth=.5, norm=divnorm)
geo_matt[geo_matt.fema_IA==1].plot('plot_ia',cmap=cmap_neg, ax=ax2, edgecolor='grey',linewidth=.5, norm=divnorm)
ax2.set_title('Matthew')
ax2.axis('off')

divnorm = TwoSlopeNorm(vmin=-1, vcenter=0, vmax=1)
geo_irma.plot('plot_ia', ax=ax3, cmap=cmap_neg, legend =True,linewidth=.5, norm=divnorm)
geo_irma[geo_irma.fema_IA==1].plot('plot_ia',cmap=cmap_neg, ax=ax3, edgecolor='grey',linewidth=.5, norm=divnorm)
ax3.set_title('Irma')
ax3.axis('off')

divnorm = TwoSlopeNorm(vmin=-1, vcenter=0, vmax=1)
geo_harv.plot('plot_ia', ax=ax4, cmap=cmap_neg, legend =True,linewidth=.5, norm=divnorm)
geo_harv[geo_harv.fema_IA==1].plot('plot_ia',cmap=cmap_neg, ax=ax4, edgecolor='grey',linewidth=.5, norm=divnorm)
ax4.set_title('Harvey')
ax4.axis('off')

divnorm = TwoSlopeNorm(vmin=-1, vcenter=0, vmax=1)
geo_mich.plot('plot_ia', ax=ax5, cmap=cmap_pos, legend =True,linewidth=.5, norm=divnorm)
geo_mich[geo_mich.fema_IA==1].plot('plot_ia',cmap=cmap_pos, ax=ax5, edgecolor='grey',linewidth=.5, norm=divnorm)
ax5.set_title('Michael')
ax5.axis('off')

divnorm = TwoSlopeNorm(vmin=-1, vcenter=0, vmax=1)
geo_flo.plot('plot_ia', ax=ax6, cmap=cmap_pos, legend =True,linewidth=.5, norm=divnorm)
geo_flo[geo_flo.fema_IA==1].plot('plot_ia',cmap=cmap_pos, ax=ax6, edgecolor='grey',linewidth=.5, norm=divnorm)
ax6.set_title('Florence')
ax6.axis('off')

fig.suptitle('Individual Aid')
plt.show()

